# 安装准备

介绍安装前需要考虑软硬件兼容性状况，以及相关的配置和准备工作。
<!-- TOC -->

- [安装准备](#安装准备)
    - [获取安装源](#获取安装源)
    - [发布包完整性校验](#发布包完整性校验)
        - [简介](#简介)
        - [前提条件](#前提条件)
        - [操作指导](#操作指导)
    - [物理机的安装要求](#物理机的安装要求)
        - [硬件兼容支持](#硬件兼容支持)
        - [最小硬件要求](#最小硬件要求)
    - [虚拟机的安装要求](#虚拟机的安装要求)
        - [虚拟化平台兼容性](#虚拟化平台兼容性)
        - [最小虚拟化空间要求](#最小虚拟化空间要求)

<!-- /TOC -->

## 获取安装源

在安装开始前，您需要获取openEuler的发布包和校验文件。

请按以下步骤获取openEuler的发布包和校验文件：

1.  登录[openEuler社区](https://openeuler.org)网站。
2.  单击“下载”。
3.  单击“获取ISO：”后面的“Link”，显示版本列表。
4.  单击“openEuler-20.03-LTS”，进入openEuler 20.03 LTS版本下载列表。
5.  单击“ISO”，进入ISO下载列表。
    -   aarch64：AArch64架构的ISO。
    -   x86\_64：x86\_64架构的ISO。
    -   source：openEuler源码ISO。

6.  根据实际待安装环境的架构选择需要下载的openEuler的发布包和校验文件。
    -   若为AArch64架构。
        1.  单击“aarch64”。
        2.  单击“openEuler-20.03-LTS-aarch64-dvd.iso”，将openEuler发布包下载到本地。
        3.  单击“openEuler-20.03-LTS-aarch64-dvd.iso.sha256sum”，将openEuler校验文件下载到本地。

    -   若为x86\_64架构。
        1.  单击“x86\_64”。
        2.  单击“openEuler-20.03-LTS-x86\_64-dvd.iso”，将openEuler发布包下载到本地。
        3.  单击“openEuler-20.03-LTS-x86\_64-dvd.iso.sha256sum”，将openEuler校验文件下载到本地。

## 发布包完整性校验

>![](C:/Users/Administrator/Downloads/openDocs/docs/content/zh/docs/Installation/public_sys-resources/icon-note.gif) **说明：**   
>本章节以AArch64架构的发布包完整性校验为例，x86\_64架构的发布包完整性校验的操作方法相同。   

### 简介

为了防止软件包在传输过程中由于网络原因或者存储设备原因出现下载不完整的问题，在获取到软件包后，需要对软件包的完整性进行校验，通过了校验的软件包才能部署。

这里通过对比校验文件中记录的校验值和手动方式计算的iso文件校验值，判断软件包是否完成。若两个值相同，说明iso文件完整，否则，iso完整性被破坏，请重新获取iso发布包。

### 前提条件

在校验发布包完整性之前，需要准备如下文件：

iso文件：openEuler-20.03-LTS-aarch64-dvd.iso

校验文件：openEuler-20.03-LTS-aarch64-dvd.iso.sha256sum

### 操作指导

文件完整性校验操作步骤如下：

1.  获取校验文件中的校验值。执行命令如下：

    ```
    #cat openEuler-20.03-LTS-aarch64-dvd.iso.sha256sum 
    ```

2.  计算文件的sha256校验值。执行命令如下：

    ```
    #sha256sum openEuler-20.03-LTS-aarch64-dvd.iso
    ```

    命令执行完成后，输出校验值。

3.  对比步骤1和步骤2计算的校验值是否一致。

    如果校验值一致说明iso文件完整性没有破坏，如果校验值不一致则可以确认文件完整性已被破坏，需要重新获取。

## 物理机的安装要求

若需要在物理机环境上安装openEuler操作系统，则物理机需要满足如下的硬件兼容性和最小硬件要求。

### 硬件兼容支持

openEuler安装时，应注意硬件兼容性方面的问题，当前已支持的服务器类型如[表1](#table14948632047)所示。

>![](C:/Users/Administrator/Downloads/openDocs/docs/content/zh/docs/Installation/public_sys-resources/icon-note.gif) **说明：**   
>
>-   TaiShan 200服务器基于华为鲲鹏920处理器。  
>-   当前仅支持华为TaiShan服务器和FusionServer Pro 机架服务器，后续将逐步增加对其他厂商服务器的支持。  

**表 1**  支持的服务器类型

<a name="table14948632047"></a>

<table><thead align="left"><tr id="row5949431547"><th class="cellrowborder" valign="top" width="26.369999999999997%" id="mcps1.2.4.1.1"><p id="p694923843"><a name="p694923843"></a><a name="p694923843"></a><strong id="b1990114912213"><a name="b1990114912213"></a><a name="b1990114912213"></a>服务器形态</strong></p>
</th>
<th class="cellrowborder" valign="top" width="24%" id="mcps1.2.4.1.2"><p id="p132705020556"><a name="p132705020556"></a><a name="p132705020556"></a><strong id="b18630171675"><a name="b18630171675"></a><a name="b18630171675"></a>服务器名称</strong></p>
</th>
<th class="cellrowborder" valign="top" width="49.63%" id="mcps1.2.4.1.3"><p id="p119491131848"><a name="p119491131848"></a><a name="p119491131848"></a><strong id="b209018491722"><a name="b209018491722"></a><a name="b209018491722"></a>服务器型号</strong></p>
</th>
</tr>
</thead>
<tbody><tr id="row8949153348"><td class="cellrowborder" valign="top" width="26.369999999999997%" headers="mcps1.2.4.1.1 "><p id="p4893192424117"><a name="p4893192424117"></a><a name="p4893192424117"></a>机架服务器</p>
</td>
<td class="cellrowborder" rowspan="1" valign="top" width="24%" headers="mcps1.2.4.1.2 "><p id="p02706012553"><a name="p02706012553"></a><a name="p02706012553"></a>TaiShan 200</p>
</td>
<td class="cellrowborder" valign="top" width="49.63%" headers="mcps1.2.4.1.3 "><p id="p126551941225"><a name="p126551941225"></a><a name="p126551941225"></a>2280均衡型</p>
</td>
</tr>
<tr id="row104064391909"><td class="cellrowborder" valign="top" width="26.369999999999997%" headers="mcps1.2.4.1.1 "><p id="p54061539609"><a name="p54061539609"></a><a name="p54061539609"></a><span id="ph643711543013"><a name="ph643711543013"></a><a name="ph643711543013"></a>机架服务器</span></p>
</td>
<td class="cellrowborder" valign="top" width="24%" headers="mcps1.2.4.1.2 "><p id="p9937105713311"><a name="p9937105713311"></a><a name="p9937105713311"></a><span id="ph103021851548"><a name="ph103021851548"></a><a name="ph103021851548"></a>FusionServer Pro 机架服务器</span></p>
</td>
<td class="cellrowborder" valign="top" width="49.63%" headers="mcps1.2.4.1.3 "><p id="p154063394011"><a name="p154063394011"></a><a name="p154063394011"></a><span id="ph1569451019115"><a name="ph1569451019115"></a><a name="ph1569451019115"></a>FusionServer Pro 2288H V5</span></p>
<div class="note" id="note2046771016316"><a name="note2046771016316"></a><a name="note2046771016316"></a><span class="notetitle"> 说明： </span><div class="notebody"><p id="p1646710101130"><a name="p1646710101130"></a><a name="p1646710101130"></a>服务器要求配置Avago 3508 RAID控制卡和启用LOM-X722网卡。</p>
</div></div>
</td>
</tr>
</tbody>
</table>

### 最小硬件要求

openEuler所需的最小硬件要求如[表2](#tff48b99c9bf24b84bb602c53229e2541)所示。

**表 2**  最小硬件要求

<a name="tff48b99c9bf24b84bb602c53229e2541"></a>

<table><thead align="left"><tr id="r36f08b63edea4973a8228200caa2a50b"><th class="cellrowborder" valign="top" width="11.19111911191119%" id="mcps1.2.4.1.1"><p id="aef3575d97cdf4dcfb65f8d0c8d2d4a76"><a name="aef3575d97cdf4dcfb65f8d0c8d2d4a76"></a><a name="aef3575d97cdf4dcfb65f8d0c8d2d4a76"></a><strong id="abf63bde6a66a4ce5b21d81948fcafe36"><a name="abf63bde6a66a4ce5b21d81948fcafe36"></a><a name="abf63bde6a66a4ce5b21d81948fcafe36"></a>部件名称</strong></p>
</th>
<th class="cellrowborder" valign="top" width="40.06400640064006%" id="mcps1.2.4.1.2"><p id="a919d3bb266c8432fb33c51fa8f3a4fc3"><a name="a919d3bb266c8432fb33c51fa8f3a4fc3"></a><a name="a919d3bb266c8432fb33c51fa8f3a4fc3"></a><strong id="a9386cf027c1e47d99651159bb62130e7"><a name="a9386cf027c1e47d99651159bb62130e7"></a><a name="a9386cf027c1e47d99651159bb62130e7"></a>最小硬件要求</strong></p>
</th>
<th class="cellrowborder" valign="top" width="48.74487448744874%" id="mcps1.2.4.1.3"><p id="a3ac7cf4867974c4990ee6deab716db5f"><a name="a3ac7cf4867974c4990ee6deab716db5f"></a><a name="a3ac7cf4867974c4990ee6deab716db5f"></a><strong id="a0206841e981640cf833dc2556a7def50"><a name="a0206841e981640cf833dc2556a7def50"></a><a name="a0206841e981640cf833dc2556a7def50"></a>说明</strong></p>
</th>
</tr>
</thead>
<tbody><tr id="r1a3ceb0cc79241c6ba8c5fb800c274e2"><td class="cellrowborder" valign="top" width="11.19111911191119%" headers="mcps1.2.4.1.1 "><p id="af37d7ef138ee45eca00898e0d34a03f4"><a name="af37d7ef138ee45eca00898e0d34a03f4"></a><a name="af37d7ef138ee45eca00898e0d34a03f4"></a>架构</p>
</td>
<td class="cellrowborder" valign="top" width="40.06400640064006%" headers="mcps1.2.4.1.2 "><a name="ul262164044016"></a><a name="ul262164044016"></a><ul id="ul262164044016"><li>AArch64</li><li>x86_64</li></ul>
</td>
<td class="cellrowborder" valign="top" width="48.74487448744874%" headers="mcps1.2.4.1.3 "><a name="ul1830173916388"></a><a name="ul1830173916388"></a><ul id="ul1830173916388"><li>支持Arm的64位架构。</li><li>支持Intel的x86 64位架构。</li></ul>
</td>
</tr>
<tr id="ra68eff5c33a84bb2be6672a48a643d26"><td class="cellrowborder" valign="top" width="11.19111911191119%" headers="mcps1.2.4.1.1 "><p id="ac0a50d2069ab444cafff180647772df4"><a name="ac0a50d2069ab444cafff180647772df4"></a><a name="ac0a50d2069ab444cafff180647772df4"></a>CPU</p>
</td>
<td class="cellrowborder" valign="top" width="40.06400640064006%" headers="mcps1.2.4.1.2 "><a name="ul97131912175915"></a><a name="ul97131912175915"></a><ul id="ul97131912175915"><li>华为鲲鹏920系列CPU</li><li>Intel<sup id="sup487664501416"><a name="sup487664501416"></a><a name="sup487664501416"></a>&reg;</sup> Xeon<sup id="sup10571950171416"><a name="sup10571950171416"></a><a name="sup10571950171416"></a>&reg;</sup>处理器</li></ul>
</td>
<td class="cellrowborder" valign="top" width="48.74487448744874%" headers="mcps1.2.4.1.3 "><p id="a2601e9eece5f4c7bb02881c9ac647a61"><a name="a2601e9eece5f4c7bb02881c9ac647a61"></a><a name="a2601e9eece5f4c7bb02881c9ac647a61"></a>-</p>
</td>
</tr>
<tr id="rf2a5d43b74894a0882b7c17bdfeb697f"><td class="cellrowborder" valign="top" width="11.19111911191119%" headers="mcps1.2.4.1.1 "><p id="ad00611ec129a41a9841fb579eece7804"><a name="ad00611ec129a41a9841fb579eece7804"></a><a name="ad00611ec129a41a9841fb579eece7804"></a>内存</p>
</td>
<td class="cellrowborder" valign="top" width="40.06400640064006%" headers="mcps1.2.4.1.2 "><p id="a94efe642b8694e5a85747e123b951efc"><a name="a94efe642b8694e5a85747e123b951efc"></a><a name="a94efe642b8694e5a85747e123b951efc"></a>不小于4GB（为了获得更好的应用体验，建议不小于8GB）</p>
</td>
<td class="cellrowborder" valign="top" width="48.74487448744874%" headers="mcps1.2.4.1.3 "><p id="abfb44d28dca741f68df94e4e276d2410"><a name="abfb44d28dca741f68df94e4e276d2410"></a><a name="abfb44d28dca741f68df94e4e276d2410"></a>-</p>
</td>
</tr>
<tr id="rd2c1ebd93ea64e85a5f3fc88dc5ba456"><td class="cellrowborder" valign="top" width="11.19111911191119%" headers="mcps1.2.4.1.1 "><p id="afd36954546334c1681b5a391bbc386ae"><a name="afd36954546334c1681b5a391bbc386ae"></a><a name="afd36954546334c1681b5a391bbc386ae"></a>硬盘</p>
</td>
<td class="cellrowborder" valign="top" width="40.06400640064006%" headers="mcps1.2.4.1.2 "><p id="p1224172312719"><a name="p1224172312719"></a><a name="p1224172312719"></a>为了获得更好的应用体验，建议不小于120GB）</p>
</td>
<td class="cellrowborder" valign="top" width="48.74487448744874%" headers="mcps1.2.4.1.3 "><p id="acc0affdd82e34f32966171e21855ef40"><a name="acc0affdd82e34f32966171e21855ef40"></a><a name="acc0affdd82e34f32966171e21855ef40"></a>支持IDE、SATA、SAS等接口的硬盘。</p>
</td>
</tr>
</tbody>
</table>

## 虚拟机的安装要求

若需要在虚拟机环境上安装openEuler操作系统，则虚拟机需要满足如下的虚拟化平台兼容性和最小虚拟化要求。

### 虚拟化平台兼容性

openEuler安装时，应注意虚拟化平台兼容性的问题，当前已支持的虚拟化平台为：

-   openEuler自有的虚拟化组件（HostOS为openEuler，虚拟化组件为发布包中的qemu、KVM）创建的虚拟化平台。
-   华为公有云的x86虚拟化平台。

### 最小虚拟化空间要求

openEuler所需的最小虚拟化空间要求如[表3](#tff48b99c9bf24b84bb602c53229e2541)所示。

**表 3**  最小虚拟化空间要求

<a name="tff48b99c9bf24b84bb602c53229e2541"></a>

<table><thead align="left"><tr id="r36f08b63edea4973a8228200caa2a50b"><th class="cellrowborder" valign="top" width="11.511151115111511%" id="mcps1.2.4.1.1"><p id="aef3575d97cdf4dcfb65f8d0c8d2d4a76"><a name="aef3575d97cdf4dcfb65f8d0c8d2d4a76"></a><a name="aef3575d97cdf4dcfb65f8d0c8d2d4a76"></a><strong id="abf63bde6a66a4ce5b21d81948fcafe36"><a name="abf63bde6a66a4ce5b21d81948fcafe36"></a><a name="abf63bde6a66a4ce5b21d81948fcafe36"></a>部件名称</strong></p>
</th>
<th class="cellrowborder" valign="top" width="39.74397439743974%" id="mcps1.2.4.1.2"><p id="a919d3bb266c8432fb33c51fa8f3a4fc3"><a name="a919d3bb266c8432fb33c51fa8f3a4fc3"></a><a name="a919d3bb266c8432fb33c51fa8f3a4fc3"></a><strong id="a9386cf027c1e47d99651159bb62130e7"><a name="a9386cf027c1e47d99651159bb62130e7"></a><a name="a9386cf027c1e47d99651159bb62130e7"></a>最小虚拟化空间要求</strong></p>
</th>
<th class="cellrowborder" valign="top" width="48.74487448744874%" id="mcps1.2.4.1.3"><p id="a3ac7cf4867974c4990ee6deab716db5f"><a name="a3ac7cf4867974c4990ee6deab716db5f"></a><a name="a3ac7cf4867974c4990ee6deab716db5f"></a><strong id="a0206841e981640cf833dc2556a7def50"><a name="a0206841e981640cf833dc2556a7def50"></a><a name="a0206841e981640cf833dc2556a7def50"></a>说明</strong></p>
</th>
</tr>
</thead>
<tbody><tr id="r1a3ceb0cc79241c6ba8c5fb800c274e2"><td class="cellrowborder" valign="top" width="11.511151115111511%" headers="mcps1.2.4.1.1 "><p id="af37d7ef138ee45eca00898e0d34a03f4"><a name="af37d7ef138ee45eca00898e0d34a03f4"></a><a name="af37d7ef138ee45eca00898e0d34a03f4"></a>架构</p>
</td>
<td class="cellrowborder" valign="top" width="39.74397439743974%" headers="mcps1.2.4.1.2 "><a name="ul12618156163"></a><a name="ul12618156163"></a><ul id="ul12618156163"><li>AArch64</li><li>x86_64</li></ul>
</td>
<td class="cellrowborder" valign="top" width="48.74487448744874%" headers="mcps1.2.4.1.3 "><p id="aa0dbd77b34bc472cbad6f8ead108471d"><a name="aa0dbd77b34bc472cbad6f8ead108471d"></a><a name="aa0dbd77b34bc472cbad6f8ead108471d"></a>-</p>
</td>
</tr>
<tr id="ra68eff5c33a84bb2be6672a48a643d26"><td class="cellrowborder" valign="top" width="11.511151115111511%" headers="mcps1.2.4.1.1 "><p id="ac0a50d2069ab444cafff180647772df4"><a name="ac0a50d2069ab444cafff180647772df4"></a><a name="ac0a50d2069ab444cafff180647772df4"></a>CPU</p>
</td>
<td class="cellrowborder" valign="top" width="39.74397439743974%" headers="mcps1.2.4.1.2 "><p id="p847135012587"><a name="p847135012587"></a><a name="p847135012587"></a>2个CPU</p>
</td>
<td class="cellrowborder" valign="top" width="48.74487448744874%" headers="mcps1.2.4.1.3 "><p id="a2601e9eece5f4c7bb02881c9ac647a61"><a name="a2601e9eece5f4c7bb02881c9ac647a61"></a><a name="a2601e9eece5f4c7bb02881c9ac647a61"></a>-</p>
</td>
</tr>
<tr id="rf2a5d43b74894a0882b7c17bdfeb697f"><td class="cellrowborder" valign="top" width="11.511151115111511%" headers="mcps1.2.4.1.1 "><p id="ad00611ec129a41a9841fb579eece7804"><a name="ad00611ec129a41a9841fb579eece7804"></a><a name="ad00611ec129a41a9841fb579eece7804"></a>内存</p>
</td>
<td class="cellrowborder" valign="top" width="39.74397439743974%" headers="mcps1.2.4.1.2 "><p id="a94efe642b8694e5a85747e123b951efc"><a name="a94efe642b8694e5a85747e123b951efc"></a><a name="a94efe642b8694e5a85747e123b951efc"></a>不小于4GB（为了获得更好的应用体验，建议不小于8GB）</p>
</td>
<td class="cellrowborder" valign="top" width="48.74487448744874%" headers="mcps1.2.4.1.3 "><p id="abfb44d28dca741f68df94e4e276d2410"><a name="abfb44d28dca741f68df94e4e276d2410"></a><a name="abfb44d28dca741f68df94e4e276d2410"></a>-</p>
</td>
</tr>
<tr id="rd2c1ebd93ea64e85a5f3fc88dc5ba456"><td class="cellrowborder" valign="top" width="11.511151115111511%" headers="mcps1.2.4.1.1 "><p id="afd36954546334c1681b5a391bbc386ae"><a name="afd36954546334c1681b5a391bbc386ae"></a><a name="afd36954546334c1681b5a391bbc386ae"></a>硬盘</p>
</td>
<td class="cellrowborder" valign="top" width="39.74397439743974%" headers="mcps1.2.4.1.2 "><p id="p1224172312719"><a name="p1224172312719"></a><a name="p1224172312719"></a>不小于<span id="ph1655615205916"><a name="ph1655615205916"></a><a name="ph1655615205916"></a>32</span>GB（为了获得更好的应用体验，建议不小于120GB）</p>
</td>
<td class="cellrowborder" valign="top" width="48.74487448744874%" headers="mcps1.2.4.1.3 "><p id="acc0affdd82e34f32966171e21855ef40"><a name="acc0affdd82e34f32966171e21855ef40"></a><a name="acc0affdd82e34f32966171e21855ef40"></a>-</p>
</td>
</tr>
</tbody>
</table>



