# 安装方式介绍

>![](public_sys-resources/icon-notice.gif) **须知：**   
>-   硬件服务器仅支持Taishan 200服务器和FusionServer Pro 机架服务器，具体支持的服务器型号可参考“[硬件兼容支持](安装准备.html#硬件兼容支持)”；虚拟化平台仅支持openEuler自有的虚拟化组件（HostOS为openEuler，虚拟化组件为发布包中的qemu、KVM）创建的虚拟化平台和华为公有云的x86虚拟化平台。  
>-   安装方式当前仅支持光盘、USB盘安装、网络安装、qcow2镜像安装和私有镜像安装。其中仅华为公有云的x86虚拟化平台支持私有镜像安装。
<!-- TOC -->

- [安装方式介绍](#安装方式介绍)
    - [通过光盘安装](#通过光盘安装)
        - [准备安装源](#准备安装源)
        - [启动安装](#启动安装)
    - [通过USB盘安装](#通过usb盘安装)
        - [准备安装源](#准备安装源-1)
        - [启动安装](#启动安装-1)
    - [使用PXE通过网络安装](#使用pxe通过网络安装)
    - [通过qcow2镜像安装](#通过qcow2镜像安装)
        - [制作qcow2镜像](#制作qcow2镜像)
        - [启动安装](#启动安装-2)
    - [通过私有镜像安装](#通过私有镜像安装)
        - [制作私有镜像](#制作私有镜像)
        - [启动安装](#启动安装-3)

<!-- /TOC -->

## 通过光盘安装

本节介绍如何使用或者制作光盘安装源，并介绍相应的操作步骤，指导用户进行安装。

### 准备安装源

如果您获取的是系统安装光盘，那么可以直接使用光盘安装系统。如果您获取的是系统ISO镜像，可以通过刻录软件将系统的ISO镜像刻录到DVD中，使用刻录完成的DVD安装系统。

### 启动安装

根据以下步骤启动安装程序：

>![](C:/Users/Administrator/Downloads/openDocs/docs/content/zh/docs/Installation/public_sys-resources/icon-note.gif) **说明：**   
>您需要先设置您的系统优先从光盘进行启动引导。以BIOS为例，您需要将“Boot Type Order”中的“CD/DVD-ROM Drive”选项调整到首位。  

1.  断开所有安装不需要的驱动器，比如USB。
2.  启动您的计算机系统。
3.  在计算机中插入安装光盘。
4.  重启计算机系统。

在短暂的延迟后会出现图形化引导界面，该界面包含不同引导选项。如果您在一分钟内未进行任何操作，安装程序将自动以默认选项开始运行。

## 通过USB盘安装

本节介绍如何制作USB盘安装源，并介绍基本的操作步骤，指导用户进行安装。

### 准备安装源

您需要注意USB盘容量的大小，它必须有足够的的空间放下整个镜像，建议USB盘空间大于16G。

1.  将USB盘连接到该系统中，并执行 dmesg 命令查看相关的日志信息。在该日志的最后可以看到刚刚连接的USB盘所生成的一组信息，应类似如下：

    ```
    [ 170.171135] sd 5:0:0:0: [sdb] Attached SCSI removable disk
    ```

    >![](C:/Users/Administrator/Downloads/openDocs/docs/content/zh/docs/Installation/public_sys-resources/icon-note.gif) **说明：**   
    >连接的USB盘名称以sdb进行举例。  

2.  切换为root用户。使用su命令，需要输入相应的密码。

    ```
    $ su - root
    ```

3.  确保USB盘没有被挂载。使用如下命令进行查询：

    ```
    # findmnt /dev/sdb
    ```

    - 如果执行此命令后无输出，表明未挂载，可以继续执行下一步。

    - 如果输出以下信息，表明USB盘已经自动挂载。

        ```
        # findmnt /dev/sdb
        TARGET   SOURCE   FSTYPE  OPTIONS
        /mnt/iso /dev/sdb iso9660 ro,relatime
        ```

        此时，您需要使用umount命令卸载该设备。

        ```
        # umount /mnt/iso
        ```

4.  使用dd命令将ISO安装镜像直接写入USB盘：

    ```
    # dd if=/path/to/image.iso of=/dev/device bs=blocksize
    ```

    使用您下载的ISO镜像文件的完整路径替换 /path/to/image.iso，使用之前由 dmesg 命令给出的设备名称替换device，同时设置合理的块大小（例如：512k）替换 blocksize，这样可以加快写入进度。

    例如：如果该ISO镜像文件位于 /home/testuser/Downloads/openEuler-20.03-LTS-aarch64-dvd.iso，同时探测到的设备名称为sdb，则该命令如下：

    ```
    # dd if=/home/testuser/Downloads/openEuler-20.03-LTS-aarch64-dvd.iso of=/dev/sdb bs=512k
    ```

5.  等待镜像写入完成，拔掉USB盘。

    镜像写入过程中不会有进度显示，当\#号再次出现时，表明写入完成。退出root账户，拔掉USB盘。此时，您可以使用该USB盘作为系统的安装源。


### 启动安装

请根据以下步骤启动安装程序：

>![](C:/Users/Administrator/Downloads/openDocs/docs/content/zh/docs/Installation/public_sys-resources/icon-note.gif) **说明：**   
>您需要先设置您的系统优先从USB进行启动引导。以BIOS为例，您需要将“Boot Type Order”中的USB选项调整到首位。  

1.  断开所有安装不需要的驱动器。
2.  打开您的计算机系统。
3.  在计算机中插入USB盘。
4.  重启计算机系统。

在短暂的延迟后会出现图形化引导页面，该页面包含不同引导选项。如果您在一分钟内未进行任何操作，安装程序将自动开始安装。

## 使用PXE通过网络安装

要使用 PXE 引导，您需要正确配置服务器以及您的计算机需支持 PXE 的网络接口。

如果目标硬件安装有支持PXE的网络接口卡，我们可以配置它从其他网络系统的文件而不是本地介质（如光盘）来引导计算机并执行Anaconda安装程序。

对于PXE网络安装，客户机通过支持PXE的网卡，向网络发送请求DHCP信息的广播，请求IP地址等信息。DHCP服务器给客户机提供一个IP地址和其他网络信息如域名服务器、ftp服务器（它提供启动安装程序所必须的文件）的IP地址或主机名，以及服务器上文件的位置。

>![](C:/Users/Administrator/Downloads/openDocs/docs/content/zh/docs/Installation/public_sys-resources/icon-note.gif) **说明：**   
>此处不详细讨论tftp、DHCP、http等服务器配置，相关详细配置请参考“[全自动化安装指导](使用kickstart自动化安装.html#全自动化安装指导)”。  

## 通过qcow2镜像安装

本节介绍如何使用或者制作qcow2镜像，并介绍相应的操作步骤，指导用户进行安装。

### 制作qcow2镜像

1.  安装qemu-img软件包。

    ```
    # dnf install -y qemu-img
    ```

2.  使用qemu-img工具的create命令，创建镜像文件，命令格式为：

    ```
    $ qemu-img create -f <imgFormat> -o <fileOption> <fileName> <diskSize>
    ```

    其中，各参数含义如下：

    -   _imgFormat_  ：镜像格式，取值为raw, qcow2等。
    -   _fileOption_  ：文件选项，用于设置镜像文件的特性，如指定后端镜像文件，压缩，加密等特性。
    -   _fileName_  ：文件名称。
    -   _diskSize_  ：磁盘大小，用于指定块磁盘设备的大小，支持的单位有K、M、G、T，分别代表KiB、MiB、GiB、TiB。

    例如，创建一个磁盘设备大小为32GB、格式为qcow2的镜像文件openEuler-imge.qcow2，命令和回显如下：

    ```
    $ qemu-img create -f qcow2 openEuler-image.qcow2 32G
    Formatting 'openEuler-image.qcow2', fmt=qcow2 size=34359738368 cluster_size=65536 lazy_refcounts=off refcount_bits=16
    ```


### 启动安装

根据以下步骤启动安装程序：

1.  准备qcow2镜像文件。
2.  准备虚拟机网络。
3.  准备UEFI引导工具集EDK II。
4.  准备虚拟机XML配置文件。
5.  创建虚拟机。
6.  启动虚拟机。

各步骤详细的操作请参考《[openEuler 20.03 LTS 虚拟化用户指南](../Virtualization/virtualization.html)》。

## 通过私有镜像安装

本节介绍如何使用或者制作私有镜像，并介绍相应的操作步骤，指导用户进行安装。

### 制作私有镜像

制作私有镜像的方法请参见[《镜像服务用户指南》](https://support.huaweicloud.com/usermanual-ims/zh-cn_topic_0013901628.html)。

### 启动安装

华为公有云的x86虚拟化平台的启动请参见[ 弹性云服务器 ECS的用户指南](https://support.huaweicloud.com/wtsnew-ecs/index.html)。

















